#include "src\misc\definer.h"

struct color{
	int r;
	int g;
	int b;
};
struct vek2{
	int x;
	int y;
	int i;
};
struct vek2 texcoords[320*200];
inline float ffsin(int i) {
	return fSIN256[i&255];
}
inline float ffcos(int i) {
	return fCOS256[i&255];
}
void calculateEF1() {
	int x,y;
	struct vek2 coord;
	float fyx = ffsin(frameCount);
	float fyx64 = 32.0f+ffsin(frameCount)*64;
	for(y=24; y<198-24; y+=2) {
		float fyy = ffcos(y*2+frameCount*2);
		float fyydiv = (1.0f+fyy/4.0f);
		float xyrd = 0;
		coord.y = (int)(fyx64+y)&127;
		coord.i = 12.0f+fyy*6.0f+fyx*6.0f;
		for(x=0; x<320-0; x+=2) {
			coord.x = (int)(xyrd+fyx+frameCount)&127;
			xyrd += fyydiv;
			texcoords[x+y*320]=coord;
		}
	}
}
void interpolate(){
	int x,y;
	int yy64;
	int yy128;
	for(y=24; y<198-24; y+=2) {
		yy64 = y*320;
		yy128 = (y+1)*320;
		for(x=0; x<320-0; x+=2) {
			struct vek2 coord_BA;
			struct vek2 coord_AB;
			struct vek2 coord_BB;

			struct vek2 coord_AA = texcoords[x+yy64];
			struct vek2 coord_CA = texcoords[x+yy64+2];
			struct vek2 coord_AC = texcoords[x+y*320+2*320];
			struct vek2 coord_CC = texcoords[x+y*320+2*320+2];

			coord_BA.x = coord_AA.x;
			coord_BA.y = (coord_AA.y + coord_CA.y) / 2.0;
			coord_BA.i = coord_AA.i;
			coord_AB.x = (coord_AA.x + coord_AC.x) / 2.0;
			coord_AB.y = (coord_AA.y + coord_AC.y) / 2.0;
			coord_AB.i = coord_AA.i;
			coord_BB.x = (coord_AA.x + coord_CC.x) / 2.0;
			coord_BB.y = coord_CC.y;
			coord_BB.i = coord_AA.i;

			texcoords[x+yy64+1] = coord_BA;
			texcoords[x+yy128] = coord_AB;
			texcoords[x+yy128+1] = coord_BB;
		}
	}
}
void drawEF1(){
	int x,y;
	for(y=24; y<198-24; y++) {
		for(x=0; x<318-0; x++) {
			struct vek2 coord = texcoords[x+y*320];
			videobuffer[x+y*320] = textr1.pixelbuffer[coord.x+coord.y*320]+4*coord.i;
		}
	}
}
int e1_once = 0;
int row_now, row_prev;
struct color e1_palette[256];
int flash = 0;

void effect1() {
	int i, j;
	row_now = row;
	flash=max(flash-12,0);
	if(e1_once==0){
		displayImage(textr1, 256);
		e1_once=1;
	    for( i = 0; i < 4; i++) {
	    	e1_palette[i].r  = textr1.palettebuffer [i*3+0];
	    	e1_palette[i].g  = textr1.palettebuffer [i*3+1];
	    	e1_palette[i].b  = textr1.palettebuffer [i*3+2];
		}
	    for( i = 4; i < 256; i++) {
	        outp(0x03c8, (byte)i);
	    	e1_palette[i].r  = max( textr1.palettebuffer [(i&3) * 3 + 0]-i/2.2,0);
	    	e1_palette[i].g  = max( textr1.palettebuffer [(i&3) * 3 + 1]-i/2.3,0);
	    	e1_palette[i].b  = max( textr1.palettebuffer [(i&3) * 3 + 2]-i/1.9,0);
	        outp(0x03c9, max( textr1.palettebuffer [(i&3) * 3 + 0]-i/2.2,0) );
	        outp(0x03c9, max( textr1.palettebuffer [(i&3) * 3 + 1]-i/2.3,0) );
	        outp(0x03c9, max( textr1.palettebuffer [(i&3) * 3 + 2]-i/1.9,0) );

	    }
		flash = 123;
	    for( i = 0; i < 320*200; i++) {
	    	videobuffer[i]=250;
	    }
	}
	for( i = 0; i < 256; i++) {
	    outp(0x03c8, (byte)i);
		outp(0x03c9, max(min(e1_palette[i].r-flash,255),0));
		outp(0x03c9, max(min(e1_palette[i].g-flash,255),0));
		outp(0x03c9, max(min(e1_palette[i].b-flash,255),0));
	}
	     outp(0x03c8, 254);
		outp(0x03c9, 44);
		outp(0x03c9, 44);
		outp(0x03c9, 44);
	     outp(0x03c8, 255);
		outp(0x03c9, 255);
		outp(0x03c9, 255);
		outp(0x03c9, 255);

    calculateEF1();
    interpolate();
    drawEF1();

	for(j=16; j<32; j++) {
		for(i=0; i<220; i++) {
			byte c = titlecard.pixelbuffer[320*j+i];
			switch(c) {
				case 1:
					videobuffer[320*j+i] = 254;
					break;
				case 2:
					videobuffer[320*j+i] = 255;
					break;
			}
		}
	}
	for(j=200-32; j<200; j++) {
		for(i=126; i<320; i++) {
			byte c = titlecard.pixelbuffer[320*j+i];
			switch(c) {
				case 1:
					videobuffer[320*j+i] = 254;
					break;
				case 2:
					videobuffer[320*j+i] = 255;
					break;
			}
		}
	}
    row_prev = row_now;
}
