#include "src\misc\definer.h"
float timee2;
struct color{
	int r;
	int g;
	int b;
};
struct vek2{
	int x;
	int y;
	int i;
};
struct vek2 texcoordTWO[640*640];
inline float ffsin(int i) {
	return fSIN256[i&255];
}
inline float ffcos(int i) {
	return fCOS256[i&255];
}
float Q_rsqrt( float number ){
	long i;
	float x2, y;
	const float threehalfs = 1.5F;

	x2 = number * 0.5F;
	y  = number;
	i  = * ( long * ) &y;                       // evil floating point bit level hacking
	i  = 0x5f3759df - ( i >> 1 );               // what the fuck? 
	y  = * ( float * ) &i;
	y  = y * ( threehalfs - ( x2 * y * y ) );   // 1st iteration
//	y  = y * ( threehalfs - ( x2 * y * y ) );   // 2nd iteration, this can be removed

	return y;
}
float pre_inv_sqrt[640][400];
void init_inv_sqrt() {
	float i, j;
	for(j=0; j<400; j++) {
		for(i=0; i<640; i++) {
			float x = i / 160.0f - 2.0f;
			float y = j / 100.0f - 2.0f;
			pre_inv_sqrt[(int)i][(int)j] = Q_rsqrt(x*x+y*y);
		}
	}
}
float inv_sqrt(float x, float y) {
	int ix = (x + 2.0f) * 160.0f;
	int iy = (y + 2.0f) * 100.0f;
	return pre_inv_sqrt[ix][iy];
}
float preATAN2[640][400];
void initpreatan2() {
	int i, j;
	float ii, jj;
	for( jj = 0; jj < 400; jj++) {
		for( ii = 0; ii < 640; ii++) {
			float x = ii / 160.0f - 2.0f;
			float y = jj / 100.0f - 2.0f;
			preATAN2[(int)ii][(int)jj] = atan2( x, y);
		}
	}
}
float atan2pre(float x, float y) {
	int ix = (x + 2.0f) * 160.0f;
	int iy = (y + 2.0f) * 100.0f;
	return preATAN2[ix][iy];
}
int pre_calc_once = 0;
void calculateEF3() {
	int x,y;
	struct vek2 coord;
	float c_x = 0.0f;
	float c_y = 0.0f;
	if( pre_calc_once == 0) {
		initpreatan2();
		init_inv_sqrt();
		pre_calc_once = 1;
	}
	for(y=0; y<640; y++) {
		float uv_x, uv_y, lenuv, p_y, angle, p_x;
		float z;
		uv_y = y / 160.0f - 2.0f;
		uv_y += c_y;
		for(x=0; x<640; x++) {
			uv_x = x / 160.0f - 2.0f;
			uv_x+=c_x;
			p_y = inv_sqrt(uv_x,uv_y);
			z = p_y;
			angle = atan2pre( uv_x, uv_y);
			//p_y += frameCount / 64.0f;
			p_x = angle;
			coord.x = (int)(p_x*100.f)&127;
			coord.y = (int)(p_y*100.f)&127;
			if( (x+y)&1 > 0)
				coord.i = min(z*z*0.4f+0.2f,10.0f);
			else
				coord.i = min(z*z*0.4f,10.0f);
			if( (x+y)&3 > 0)
				coord.i += 0.3f;
			texcoordTWO[x+y*640]=coord;
		}
	}
}
void interpolate3_before(){
	int x,y;
	for(y=0; y<398; y+=2) {
		for(x=0; x<638; x+=8) {
			struct vek2 coord_0, coord_1, coord_2, coord_3, 
						coord_4, coord_5, coord_6, coord_7, 
						coord_8, coord_C;

			coord_0 = texcoordTWO[x+y*320];
			coord_8 = texcoordTWO[x+y*320+8];
			coord_C = texcoordTWO[x+y*320+2*320+8];
			coord_1.x = coord_0.x * (7.0f/8.0f) + coord_8.x * (1.0f/8.0f);
			coord_2.x = coord_0.x * (6.0f/8.0f) + coord_8.x * (2.0f/8.0f);
			coord_3.x = coord_0.x * (5.0f/8.0f) + coord_8.x * (3.0f/8.0f);
			coord_4.x = coord_0.x * (4.0f/8.0f) + coord_8.x * (4.0f/8.0f);
			coord_5.x = coord_0.x * (3.0f/8.0f) + coord_8.x * (5.0f/8.0f);
			coord_6.x = coord_0.x * (2.0f/8.0f) + coord_8.x * (6.0f/8.0f);
			coord_7.x = coord_0.x * (1.0f/8.0f) + coord_8.x * (7.0f/8.0f);

			coord_1.i = coord_0.i;
			coord_2.i = coord_0.i;
			coord_3.i = coord_0.i;
			coord_4.i = coord_0.i;
			coord_5.i = coord_0.i;
			coord_6.i = coord_0.i;
			coord_7.i = coord_0.i;

			coord_1.y = coord_0.y * (7.0f/8.0f) + coord_8.y * (1.0f/8.0f);
			coord_2.y = coord_0.y * (6.0f/8.0f) + coord_8.y * (2.0f/8.0f);
			coord_3.y = coord_0.y * (5.0f/8.0f) + coord_8.y * (3.0f/8.0f);
			coord_4.y = coord_0.y * (4.0f/8.0f) + coord_8.y * (4.0f/8.0f);
			coord_5.y = coord_0.y * (3.0f/8.0f) + coord_8.y * (5.0f/8.0f);
			coord_6.y = coord_0.y * (2.0f/8.0f) + coord_8.y * (6.0f/8.0f);
			coord_7.y = coord_0.y * (1.0f/8.0f) + coord_8.y * (7.0f/8.0f);

			texcoordTWO[x+y*320+1] = coord_1;
			texcoordTWO[x+y*320+2] = coord_2;
			texcoordTWO[x+y*320+3] = coord_3;
			texcoordTWO[x+y*320+4] = coord_4;
			texcoordTWO[x+y*320+5] = coord_5;
			texcoordTWO[x+y*320+6] = coord_6;
			texcoordTWO[x+y*320+7] = coord_7;
		}
	}
}
void interpolate3(){
	int x,y;
	for(y=0; y<398; y+=2) {
		for(x=0; x<638; x+=8) {
			//struct vek2 coord_BA;
			struct vek2 coord_AB;
			struct vek2 coord_BB;

			struct vek2 coord_AA = texcoordTWO[x+y*320];
			struct vek2 coord_CA = texcoordTWO[x+y*320+2];
			struct vek2 coord_AC = texcoordTWO[x+y*320+2*320];
			struct vek2 coord_CC = texcoordTWO[x+y*320+2*320+2];

			//coord_BA.x = (coord_AA.x + coord_CA.x) / 2.0;
			//coord_BA.y = (coord_AA.y + coord_CA.y) / 2.0;
			//coord_BA.i = (coord_AA.i + coord_CA.i) / 2.0;
			coord_AB.x = (coord_AA.x + coord_AC.x) / 2.0;
			coord_AB.y = coord_AA.y;
			coord_AB.i = (coord_AA.i + coord_AC.i) / 2.0;
			coord_BB.x = coord_AA.x;
			coord_BB.y = (coord_AA.y + coord_CC.y) / 2.0;
			coord_BB.i = coord_AA.i;

			//texcoordTWO[x+y*320+1] = coord_BA;
			texcoordTWO[x+y*320+320] = coord_AB;
			texcoordTWO[x+y*320+321] = coord_BB;
		}
	}
}
int flipef3=0;
void drawEF3(){
	int x,y,y16;
	float real_x=cos(frameCount/80.0f)*160.0f+160.0f;
	float real_y=sin(frameCount/50.0f)*40.0f+220.0f;
	int real_x_int = real_x;
	y16=(int)real_y*640;
	for(y=0; y<200; y++) {
		for(x=0; x<320; x++) {
			struct vek2 coord = texcoordTWO[(x+real_x_int)+y16];
			coord.x=(coord.x+frameCount)&127;
			coord.y=(coord.y+frameCount*2)&127;
			videobuffer[x+y*320] = textr3.pixelbuffer[coord.x+coord.y*320]+16*coord.i;
		}
		y16+=640;
	}
}
int e3_once = 0;
int row_now, row_prev;
struct color e1_palette[256];
int flash = 0;
float startTime;
void effect3() {
    dword *dwordBuffer=(dword *)&videobuffer;
	int i, j;
	row_now = row;
	flash=max(flash-12,0);
	if(e3_once==0){
		displayImage(textr3, 256);
		e3_once=1;
	    for( i = 0; i < 16; i++) {
	    	e1_palette[i].r  = textr3.palettebuffer [i*3+0];
	    	e1_palette[i].g  = textr3.palettebuffer [i*3+1];
	    	e1_palette[i].b  = textr3.palettebuffer [i*3+2];
		}
	    for( i = 16; i < 256; i++) {
	        outp(0x03c8, (byte)i);
	    	e1_palette[i].r  = max( textr3.palettebuffer [(i&15) * 3 + 0]-i/3.2,0);
	    	e1_palette[i].g  = max( textr3.palettebuffer [(i&15) * 3 + 1]-i/3.1,0);
	    	e1_palette[i].b  = max( textr3.palettebuffer [(i&15) * 3 + 2]-i/3.8,0);
	        outp(0x03c9, max( textr2.palettebuffer [(i&15) * 3 + 0]-i/3.8,0) );
	        outp(0x03c9, max( textr2.palettebuffer [(i&15) * 3 + 1]-i/3.8,0) );
	        outp(0x03c9, max( textr2.palettebuffer [(i&15) * 3 + 2]-i/3.8,0) );

	    }
		flash = 123;
		startTime = frameCount;

	}
	timee2 = frameCount - startTime;
	for( i = 0; i < 256; i++) {
		outp(0x03c8, (byte)i);
		outp(0x03c9, max(min(e1_palette[i].r-flash,255),0));
		outp(0x03c9, max(min(e1_palette[i].g-flash,255),0));
		outp(0x03c9, max(min(e1_palette[i].b-flash,255),0));
	}
	outp(0x03c8, 254);
	outp(0x03c9, 44);
	outp(0x03c9, 44);
	outp(0x03c9, 44);
	outp(0x03c8, 255);
	outp(0x03c9, 255);
	outp(0x03c9, 255);
	outp(0x03c9, 250);
    drawEF3();
	
		for(j=0; j<200; j++) {
			for(i=16; i<48; i++) {
				byte c = pcamiatr.pixelbuffer[320*j+i];
				switch(c) {
					case 1:
						videobuffer[320*j+i] = 254;
						break;
					case 2:
						videobuffer[320*j+i] = 255;
						break;
				}
			}
		}

    row_prev = row_now;
}
